//====================================================================
//==============            FindLpt 1.2               ================
//==========   Copyright (c)  2003 Victor Ishikeev   =============
//==============    mailto: tools@entechtaiwan.com    ================
//============   http://www.entechtaiwan.com/tools.htm   =============
//====================================================================

#include <windows.h>
#include <winioctl.h>
#include <winsvc.h>
#include <stdio.h>

#include "FindLpt.h"

//////////////////////////////////////////////////////////////////////
// FindLpt.cpp: implementation of the FindLpt class.
//
//////////////////////////////////////////////////////////////////////


void OpenSubKey(HKEY MainKey,
					 const char * SubKey,
					 HKEY* hSubKey,
					 DWORD* cSubKeys,
					 DWORD *NumKeys)
{

	char achClass[256];
    DWORD cchClassName,cbMaxSubKey;
    DWORD cchMaxClass,cbMaxValueData,cbSecurityDescriptor;
    DWORD cchMaxValue, Reserv;
    _FILETIME ftLastWriteTime;

	memset(achClass,0,sizeof(achClass));
	cchClassName = 255;
	*cSubKeys = 0;
	*NumKeys  = 0;

    Reserv = RegOpenKeyEx(
		MainKey,
		SubKey,
		0,
		KEY_READ,
		hSubKey);
	if (Reserv == ERROR_SUCCESS)
	{
		RegQueryInfoKey (*hSubKey,
			achClass,
            &cchClassName,
            NULL,
            cSubKeys,
            &cbMaxSubKey,
            &cchMaxClass,
            NumKeys,
            &cchMaxValue,
            &cbMaxValueData,
            &cbSecurityDescriptor,
            &ftLastWriteTime);
	}
	else *hSubKey = 0;
}

//-------------------------------------------------------
BOOL SearchKeyValue(HKEY hSubKey,
					DWORD NumKeys,
					const char *KeyName,
					unsigned char *OutBuffer)
{
	DWORD retValue,type_key,LBuf,cchMaxValue;
    char achValue[512];
    WORD n;
	BOOL result;

    result = FALSE;
	if ( NumKeys > 0 ) 
	{
		for (n=0;n<= NumKeys-1 ; n++)
		{
			cchMaxValue = 512; LBuf = 512;  result =  FALSE;
			retValue = RegEnumValue(hSubKey, 
									n, 
									achValue, 
									&cchMaxValue, 
									NULL,
									&type_key, 
									OutBuffer, 
									&LBuf);
			if (retValue == ERROR_SUCCESS)
				if ( strcmp(achValue, KeyName) == 0)
					return TRUE;
		}
	}
	return result;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
TFindLpt::TFindLpt()
{
  OSVERSIONINFO WinVer;

  m_NT5 = false;
  m_Win95 = (GetVersion() & 0x80000000)!=0;
  if (!m_Win95)
  {
    WinVer.dwOSVersionInfoSize = sizeof(WinVer);
    GetVersionEx(&WinVer);
    if (WinVer.dwMajorVersion>4) m_NT5=1;
  }
	
}
//-------------------------------------------------------
BYTE TFindLpt::GetIRQCounter()
{
	return m_IRQCounter;
}
//-------------------------------------------------------
BYTE TFindLpt::GetIRQNumber()
{
	return (BYTE)m_IRQNumber;
}
//-------------------------------------------------------
BYTE TFindLpt::GetDMACounter()
{
	return m_DMACounter;
}
//-------------------------------------------------------
BYTE TFindLpt::GetDMAChannel()
{
	return (BYTE) m_DMAChannel;
}
//-------------------------------------------------------
BYTE TFindLpt::GetPortCounter()
{
	return m_PortCounter;
}
//-------------------------------------------------------
WORD TFindLpt::GetPortBase(BYTE nom)
{
  if ((nom==0) || (nom>m_PortCounter))
     return 0xFFFF;
  else
    return (WORD)m_PortBase[nom];
}
//-------------------------------------------------------
WORD TFindLpt::GetPortEnd(BYTE nom)
{
  if ((nom==0) || (nom>m_PortCounter))
    return 0xFFFF;
  else
    return m_PortEnd[nom];
}
//-------------------------------------------------------
BOOL TFindLpt::SearchLpt(BYTE Port_Number)
{
	sprintf(m_ClassN, "LPT%d", Port_Number);
	if (m_Win95)
		return SearchLpt_9X();
	else
		return SearchLpt_NT();
}
//-------------------------------------------------------
BOOL  TFindLpt::SearchLpt_9X()
{
	char  s[256],HWKey[256],DD[256];
    TIRQ95Config IRQConfig;
    TPort95Config PortConfig;
    TDMA95Config DMAConfig;
    char achKey[1024];
	unsigned char	Buffer[1024], LogBuffer[1024];
    DWORD KeysInDynKey,KeysInLM,i,SubKeys,nn;
    HKEY hLMKey,hDynKey,hLocDynKey;
    char KeyLMValue[256];
    DWORD BegBuffer;
    DWORD PStatus;
    TPort95Config TmpPortConfig;

	m_Devices = 0;
	
	m_IRQCounter = 0;
	m_DMACounter = 0;
	m_PortCounter = 0;

	
	memset(&IRQConfig,0,sizeof(TIRQ95Config));
	memset(&DMAConfig,0,sizeof(TDMA95Config));
	memset(&PortConfig,0, sizeof(TPort95Config));

	OpenSubKey(HKEY_DYN_DATA,"Config Manager\\Enum",&hDynKey,&SubKeys,&KeysInDynKey);

	i=0;

	while (i<SubKeys)
	{
		RegEnumKey(hDynKey,i,achKey,1024);

		strcpy(s, "Config Manager\\Enum\\");
		strcat(s, (char*)achKey);
		
		OpenSubKey(HKEY_DYN_DATA,s,&hLocDynKey,&nn,&KeysInDynKey);
		memset(Buffer,0,sizeof(Buffer));
		SearchKeyValue(hLocDynKey,KeysInDynKey,"Problem", Buffer);
		memcpy(&PStatus, Buffer, sizeof(PStatus));
		
		memset(Buffer,0,sizeof(Buffer));
		SearchKeyValue(hLocDynKey,KeysInDynKey,"HardWareKey",Buffer);
		strcpy(HWKey,(const char *)Buffer);

		memset(Buffer,0,sizeof(LogBuffer));
		SearchKeyValue(hLocDynKey,KeysInDynKey,"Allocation",LogBuffer);
		RegCloseKey(hLocDynKey);

		if (HWKey)
		{
			char tmp[256];
			strcpy(tmp,"Enum\\");
			strcat(tmp, HWKey);
			OpenSubKey(HKEY_LOCAL_MACHINE, tmp,&hLMKey,&nn,&KeysInLM);
			if (hLMKey!=0)
			{
				SearchKeyValue(hLMKey,KeysInLM,"Class",Buffer);
				strcpy(KeyLMValue,(const char *) Buffer);
				SearchKeyValue(hLMKey,KeysInLM,"DeviceDesc",Buffer);
				strcpy(DD,(const char *) Buffer);
				RegCloseKey(hLMKey);
			}
			else  memset(KeyLMValue,0,sizeof(KeyLMValue));

			
			if ((  !_strnicmp(KeyLMValue,"Port",4)    ||
				   !_strnicmp(KeyLMValue,"Ports", 5) )
					&& (PStatus==0)   && strstr(DD, m_ClassN)>0)
			{
				BegBuffer = 8;

				m_Devices++;

				while (LogBuffer[BegBuffer] > 0)
				{

					memcpy(&TmpPortConfig, &LogBuffer[BegBuffer],8);

					switch (TmpPortConfig.TypeRecord)
					{
						case ResType_IO:
							memcpy(&PortConfig, &LogBuffer[BegBuffer], sizeof(TPort95Config));
							m_PortCounter++;
							m_PortBase[m_PortCounter] = PortConfig.IOD_Alloc_Base;
							m_PortEnd[m_PortCounter]  = PortConfig.IOD_Alloc_End;
						break;
						case ResType_IRQ:
							memcpy(&IRQConfig, &LogBuffer[BegBuffer], sizeof(TIRQ95Config));
							m_IRQCounter++;
							m_IRQNumber = (BYTE)IRQConfig.IRQD_Alloc_Num;
						break;
						case ResType_DMA:
							memcpy(&DMAConfig, &LogBuffer[BegBuffer],sizeof(TDMA95Config));
							m_DMACounter++;
							m_DMAChannel = DMAConfig.DD_Alloc_Chan;
							break;
					}// case

					BegBuffer = BegBuffer+TmpPortConfig.LengthRecord;
				} // while
				
				RegCloseKey(hDynKey);
				return TRUE;
			} //if
		} //if
		i++;
	} //while
  RegCloseKey(hDynKey);
  return  m_Devices > 0;
}
//-------------------------------------------------------
BOOL TFindLpt::SearchLpt_NT()
{
	char sLevel1[256],sLevel2[256],sLevel3[256],sLevel4[256];
	char ClassString[256],DD[256];
    CM_RESOURCE_LIST ResList;
	BYTE  i,j;
    char achKey[1024];
    DWORD KeysInKey0,KeysInKey1,KeysInKey2,KeysInKey3,KeysInKey4;
    DWORD SubKeys0,  SubKeys1,  SubKeys2,  SubKeys3,  SubKeys4;
    DWORD Level0,    Level1,    Level2;
    HKEY Key0,Key1,Key2,Key3,Key4;
    unsigned char Buffer[1024];
    BOOL Qres;

	const char sLevel0[30] = "SYSTEM\\CurrentControlSet\\Enum";  

	m_Devices   = 0;

	m_IRQCounter  = 0;
	m_DMACounter  = 0;
	m_PortCounter = 0;

	OpenSubKey(HKEY_LOCAL_MACHINE,sLevel0,&Key0,&SubKeys0,&KeysInKey0);

	if (SubKeys0 > 0)
	{
		for (Level0=0; Level0<SubKeys0 ; Level0++)
		{
			
			RegEnumKey(Key0,Level0,achKey,1024);

			sprintf(sLevel1,"%s\\%s",sLevel0, achKey);

			OpenSubKey(HKEY_LOCAL_MACHINE,sLevel1,&Key1,&SubKeys1,&KeysInKey1);

			if (SubKeys1 > 0)
			{
				for (Level1=0; Level1<SubKeys1; Level1++)
				{
					RegEnumKey(Key1,Level1,achKey,1024);
					sprintf(sLevel2,"%s\\%s",sLevel1, achKey);
					
					OpenSubKey(HKEY_LOCAL_MACHINE,sLevel2,&Key2,&SubKeys2,&KeysInKey2);

					if (SubKeys2 > 0)
					{
						for (Level2=0; Level2 < SubKeys2;Level2++ )
						{
							RegEnumKey(Key2,Level2,achKey,1024);
							sprintf(sLevel3,"%s\\%s",sLevel2, achKey);

							OpenSubKey(HKEY_LOCAL_MACHINE,sLevel3,&Key3,&SubKeys3,&KeysInKey3);
							
							memset(Buffer,0,sizeof(Buffer));
							SearchKeyValue(Key3,KeysInKey3,"Class",Buffer);

							strcpy(ClassString, (const char *)Buffer);

							if ( !SearchKeyValue(Key3,KeysInKey3,"FriendlyName",Buffer))
											SearchKeyValue(Key3,KeysInKey3,"DeviceDesc", Buffer);
							strcpy(DD,(const char *)Buffer);

							if (!_strnicmp(ClassString,"Ports",5) && strstr(DD, m_ClassN)>0)
							{
								if (!m_NT5)
									sprintf(sLevel4,"%s\\LogConf",sLevel3);
								else 
									sprintf(sLevel4,"%s\\Control",sLevel3);

								OpenSubKey(HKEY_LOCAL_MACHINE,sLevel4, &Key4,&SubKeys4,&KeysInKey4);
									
								if (!m_NT5) 
									Qres = SearchKeyValue(Key4, KeysInKey4, "BootConfig", (unsigned char*)&ResList);
								else 
									Qres = SearchKeyValue(Key4,KeysInKey4,"AllocConfig",(unsigned char*)&ResList);

								if (Qres) 
								{
									m_Devices++;
									for (i=0; i<ResList.Count; i++)	
									{
										for (j=0; j < ResList.List[i].PartialResourceList.Count;j++ )	
										{
											switch (ResList.List[i].PartialResourceList.PartialDescriptors[j].TypeResource)
											{
												case CmResourceTypePort:      // port i/o area
													m_PortCounter++;
													m_PortBase[m_PortCounter] = 
														(WORD) ResList.List[i].PartialResourceList.PartialDescriptors[j].PortResource.Start[0];
													m_PortEnd[m_PortCounter]  = 
														ResList.List[i].PartialResourceList.PartialDescriptors[j].PortResource.Start[0]+
														ResList.List[i].PartialResourceList.PartialDescriptors[j].PortResource.Length-1;
												break;
												case CmResourceTypeInterrupt: // irq#
													m_IRQCounter++;
													m_IRQNumber = 
														(BYTE)ResList.List[i].PartialResourceList.PartialDescriptors[j].InterruptResource.Vector;
												break;
												case CmResourceTypeDma:       // DMA channel
													m_DMACounter++;
													m_DMAChannel = 
														(BYTE)ResList.List[i].PartialResourceList.PartialDescriptors[j].DMAResource.Channel;
												break;
											} //switch
										}//	for 
									}	//for
									RegCloseKey(Key3);
									RegCloseKey(Key2);
									RegCloseKey(Key1);
									RegCloseKey(Key0);
									return TRUE;
								}	//if
							} //if 
							RegCloseKey(Key3); 
						} //for 
					} //if 
					RegCloseKey(Key2);
				} //for 
			} // if 
			RegCloseKey(Key1);
		}	// for			
	}	//	if 
	RegCloseKey(Key0);
	return m_Devices > 0;
}

