//====================================================================
//==============            FindLpt 1.3               ================
//==========   Copyright (c) 2003 Victor Ishikeev        =============
//==============    mailto: tools@entechtaiwan.com    ================
//============   http://www.entechtaiwan.com/tools.htm   =============
//====================================================================



#ifndef _FINDLPT_H_
#define _FINDLPT_H_

//#ifdef __cplusplus
//extern "C" {
//#endif


//===========Find LPT ===========================================================
const	ResType_IO    = 0x00000002;      // Physical IO address resource.
const	ResType_DMA   = 0x00000003;      // DMA channels 0-7 resource.
const	ResType_IRQ   = 0x00000004;      // IRQ 0-15 resource.

struct  TPort95Config
{
    DWORD LengthRecord;
    DWORD TypeRecord;   // ResType_IO   = $00000002;
    WORD IOD_Count;
    WORD IOD_Type;
    WORD IOD_Alloc_Base;
    WORD IOD_Alloc_End;
    WORD IOD_DesFlags;
    BYTE IOD_Alloc_Alias;
    BYTE IOD_Alloc_Decode;
    WORD IOR_Align;		// Mask for base alignment
    WORD IOR_nPorts;	// Number of ports
    WORD IOR_Min;		// Min port address
    WORD IOR_Max;		// Max port address
    WORD IOR_RangeFlags;// Flags
    BYTE IOR_Alias;		// Alias offset
    BYTE IOR_Decode;	// Address specified
};

struct TDMA95Config 
{
	DWORD LengthRecord;
	DWORD TypeRecord;   // ResType_DMA   = $00000003;
	BYTE DD_Flags;
	BYTE DD_Alloc_Chan;	// Channel number allocated
	BYTE DD_Req_Mask;
	BYTE DD_Reserved;
};

struct TIRQ95Config
{
	DWORD LengthRecord;
	DWORD TypeRecord;	// ResType_IRQ   = $00000004;
	WORD IRQD_Flags;
	WORD IRQD_Alloc_Num;// Allocated IRQ number
	WORD IRQD_Req_Mask;
	WORD IRQD_Reserved;
};

//========================================================================
//======================    Windows NT/2000/XP   =========================
//========================================================================

const CmResourceTypePort             =  1;
const CmResourceTypeInterrupt        =  2;
const CmResourceTypeMemory           =  3;
const CmResourceTypeDma              =  4;

typedef long int PHYSICAL_ADDRESS[2];

typedef struct _TPortResource_NT
{
    PHYSICAL_ADDRESS Start;
    long int Length;
}TPortResource_NT,*pPortResource_NT;

typedef struct _TInterruptResource_NT
{
    long int Level;
    long int Vector;
    long int Affinity;
}TInterruptResource_NT,*pInterruptResource_NT;

typedef struct _TDMAResource_NT
{
    long int Channel;
    long int PortAddr;
    long int Reserved1;
}TDMAResource_NT,*pDMAResource_NT;

typedef struct _CM_PARTIAL_RESOURCE_DESCRIPTOR
{
    BYTE TypeResource;		// Specifies type of resource
    BYTE ShareDisposition;  // Specifies how this resourse can be shared
    WORD Flags;				// Specifies type-dependent information

	union
	{
		TPortResource_NT PortResource;
		TInterruptResource_NT InterruptResource;
		TDMAResource_NT DMAResource;
	};
}CM_PARTIAL_RESOURCE_DESCRIPTOR,*pCM_PARTIAL_RESOURCE_DESCRIPTOR;

typedef struct _CM_PARTIAL_RESOURCE_LIST
{
    WORD Version;           // The version number of this structure.
    WORD Revision;          // The revision of this structure.
    long int Count;			// The number of partial resource descriptors
    CM_PARTIAL_RESOURCE_DESCRIPTOR PartialDescriptors[8];
}CM_PARTIAL_RESOURCE_LIST,*pCM_PARTIAL_RESOURCE_LIST;

typedef struct _CM_FULL_RESOURCE_DESCRIPTOR
{
    DWORD InterfaceType;	// Specifies the bus interface type
    DWORD BusNumber;		// The zero-based number for this bus
    CM_PARTIAL_RESOURCE_LIST PartialResourceList;
}CM_FULL_RESOURCE_DESCRIPTOR,*pCM_FULL_RESOURCE_DESCRIPTOR;

typedef struct _CM_RESOURCE_LIST
{
    long int Count;         // The number of full resource descriptors
    CM_FULL_RESOURCE_DESCRIPTOR List[8];
}CM_RESOURCE_LIST,*pCM_RESOURCE_LIST;


//===========================================================================
//============    TFindLpt Class Declarations      ==========================
//===========================================================================

typedef struct _TFindLpt

{

	BOOL m_Win95;
	BOOL m_NT5;
	char m_ClassN[256];
    WORD m_Devices;
    BYTE m_IRQCounter;
	BYTE m_IRQNumber;
    BYTE m_DMACounter;
    BYTE m_DMAChannel; 
    BYTE m_PortCounter;
    WORD m_PortBase[2];      
    WORD m_PortEnd[2];

};

    BOOL SearchLpt_9X();
    BOOL SearchLpt_NT();
	void OpenFindLpt();
    BOOL SearchLpt(BYTE Port_Number);
	BYTE GetNumIrqs(); 
    BYTE GetIrqVector();
	BYTE GetNumDmas();
    BYTE GetDMAChannel(); 
	BYTE GetNumPorts();
    WORD GetPortBase(BYTE Index); 
	WORD GetPortEnd(BYTE Index); 



//#ifdef __cplusplus
// }
//#endif

#endif