/* ========================================================================
   =================         TVicHW32  DLL             ====================
   =================   Ring0 access support            ====================
   ==========            Shareware Version 5.0                  ===========
   ==========     Copyright (c) 2000 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */

#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <stdio.h>

#include "TVicVar.h"

#include "common.h"
#include "TVicHW32.h"

extern BOOL IsWow64;

__declspec(naked) void Ring0Wrapper(void)
{

	__asm {

		cmp  edi,0
		jz   proc

       	cmp  edi,1 ; RB
		jnz  WB
        in   al,dx
		retf

    WB: cmp  edi,4
		jnz  RW
		out  dx,al
        retf 

    RW: cmp  edi,2
		jnz  WW
		in   ax,dx
        retf 

    WW: cmp  edi,5
		jnz  RL
		out  dx,ax
        retf 

    RL: cmp  edi,3
		jnz  WL
		in   eax,dx
        retf 

    WL: cmp  edi,6
		jnz  proc
		out  dx,eax
        retf 

    proc:
        push edi
        call ebx
		retf

	}

}


BOOL PrepareRing0Call(PVicHW32Descriptor HW32)
{

    DWORD                 BytesReturned;
   

    if (!HW32 || !HW32->fOpenDrive) return FALSE;


	if (IsWow64) return FALSE;


	HW32->CallGateInfo.FunctionLinearAddress = Ring0Wrapper;

	if ( DeviceIoControl(HW32->hDrv,
	   			         CtlCode(CALLGATE_CREATE),
                         &(HW32->CallGateInfo),
                         sizeof(CallGate),
                         &(HW32->CallGateInfo),
                         sizeof(CallGate),
                         &BytesReturned,
                         NULL))
	{
		    HW32->fLastDebugCode = 0;
			return TRUE;

	}

	HW32->fLastDebugCode = GetLastError();

	return FALSE;
	   
}

BOOL DestroyRing0Call(PVicHW32Descriptor HW32)
{


	DWORD BytesReturned;

	if (!HW32 || !HW32->fOpenDrive || !HW32->fCallGateCreated || IsWow64) return FALSE;
	
	if (DeviceIoControl(HW32->hDrv,
                        CtlCode(CALLGATE_RELEASE),
                        &(HW32->CallGateInfo),
                        sizeof(CallGate),
                        &(HW32->CallGateInfo),
                        sizeof(CallGate),
                        &BytesReturned,
                        NULL)) 
	{
		    return TRUE;
	}

	return FALSE;

}

ULONG VICFN RunRing0Function(PVicHW32Descriptor HW32,
							TRing0Function     R0func,
							PVOID              pParm)
{
		WORD  farcall[3];
		ULONG rez;

		if (!HW32 || !HW32->fOpenDrive || IsWow64) return 0;

		if (!HW32->fCallGateCreated)
		{
			HW32->fCallGateCreated = PrepareRing0Call(HW32);
			if (!HW32->fCallGateCreated) return 0;
		}


		farcall[0] = 0;
		farcall[1] = 0;
		farcall[2]= (WORD) HW32->CallGateInfo.CallGateSelector;


        _asm {
			
			mov  ebx,R0func
			mov  edi,pParm
			call fword ptr [farcall]
			mov  rez,eax
		}
        
		return rez;

}
