/* ========================================================================
   =================         TVicHW32  DLL             ====================
   =================   HDD hardware information        ====================
   ==========            Shareware Version 5.0                  ===========
   ==========     Copyright (c) 2000 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */

#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <stdio.h>

#include "TVicVar.h"
#include "common.h"
#include "TVicHW32.h"

char *GetAsciiString (WORD in_data [], int off_start, int off_end)
{
  static char ret_val [255];
  int loop, loop1;
  for (loop = off_start, loop1 = 0; loop <= off_end; loop++)
    {
      ret_val [loop1++] = (char) (in_data [loop] / 256);  /* Get High byte */
      ret_val [loop1++] = (char) (in_data [loop] % 256);  /* Get Low byte */
    }
  ret_val [loop1] = '\0';  /* Make sure it ends in a NULL character */
  return (ret_val);
}

void  VICFN GetHDDInfo(PVicHW32Descriptor HW32,
					   USHORT IdeNumber, 
					   USHORT Master,
					   pHDDInfo Info)
{


  DWORD nByte;
  WORD  SectorW[512];
  GET_HDD dNumber;
  int n;
 
  if ((!HW32) || (!HW32->fOpenDrive) ) return;

  if (IdeNumber>4) IdeNumber = 1;
  dNumber.IdeNumber = (UCHAR)IdeNumber;
  dNumber.IdeMaster = (UCHAR)(Master & 0x0001);

  n = 0;

  DeviceIoControl(HW32->hDrv,
                  CtlCode(GET_HDD_INFO),
                  &dNumber,4,&SectorW,1024,
                  &nByte,NULL);

  while ( ((UCHAR)SectorW[27]==0)  && (SectorW[0] == 0) && (n<8)  ){

	  Sleep(200);

	  DeviceIoControl(HW32->hDrv,
                  CtlCode(GET_HDD_INFO),
                  &dNumber,4,&SectorW,1024,
                  &nByte,NULL);
	  ++n;
  }


  strcpy(Info->Model,GetAsciiString(SectorW,27,41)); 
  strcpy(Info->SerialNumber,GetAsciiString(SectorW,10,19));
  strcpy(Info->Revision,GetAsciiString(SectorW,23,26));
  Info->DoubleTransfer  = 0;
  if (SectorW[48]==0)  Info->DoubleTransfer  = 1;     
  Info->ControllerType       = (UCHAR)SectorW[20];
  Info->BufferSize           = ((ULONG)SectorW[21])*((ULONG)512);
  Info->ECCMode              = SectorW[22];
  Info->SectorsPerInterrupt  = SectorW[47]; 
  nByte = SectorW[61];
  nByte = nByte << 16;
  nByte = nByte + SectorW[60];
  Info->Cylinders            = nByte;
  Info->Heads                = SectorW[3];
  Info->SectorsPerTrack      = SectorW[6];

}

typedef struct _HDDInfoVb {

       DWORD      BufferSize;
       DWORD      DoubleTransfer;
       DWORD      ControllerType;
       DWORD      ECCMode;
       DWORD      SectorsPerInterrupt;
       DWORD      Cylinders;
       DWORD      Heads;
       DWORD      SectorsPerTrack;
       char       Model[48];
       char       SerialNumber[24];
       char       Revision[16];

} HDDInfoVb, *pHDDInfoVb;

void  VICFN GetHDDInfoVb(PVicHW32Descriptor HW32,
					        USHORT IdeNumber, 
					        USHORT Master,
					        pHDDInfoVb Info)
{


  DWORD nByte;
  WORD  SectorW[512];
  GET_HDD dNumber;
  int n;
 
  if ((!HW32) || (!HW32->fOpenDrive) ) return;

  if (IdeNumber>4) IdeNumber = 1;
  dNumber.IdeNumber = (UCHAR)IdeNumber;
  dNumber.IdeMaster = (UCHAR)(Master & 0x0001);

  n = 0;

  DeviceIoControl(HW32->hDrv,
                  CtlCode(GET_HDD_INFO),
                  &dNumber,4,&SectorW,1024,
                  &nByte,NULL);

  while ( ((UCHAR)SectorW[27]==0)  && (SectorW[0] == 0) && (n<8)  ){

	  Sleep(200);

	  DeviceIoControl(HW32->hDrv,
                  CtlCode(GET_HDD_INFO),
                  &dNumber,4,&SectorW,1024,
                  &nByte,NULL);
	  ++n;
  }


  strcpy(Info->Model,GetAsciiString(SectorW,27,41)); 
  strcpy(Info->SerialNumber,GetAsciiString(SectorW,10,19));
  strcpy(Info->Revision,GetAsciiString(SectorW,23,26));
  Info->DoubleTransfer  = 0;
  if (SectorW[48]==0)  Info->DoubleTransfer  = 1;     
  Info->ControllerType       = (UCHAR)SectorW[20];
  Info->BufferSize           = ((ULONG)SectorW[21])*((ULONG)512);
  Info->ECCMode              = SectorW[22];
  Info->SectorsPerInterrupt  = SectorW[47]; 
  nByte = SectorW[61];
  nByte = nByte << 16;
  nByte = nByte + SectorW[60];
  Info->Cylinders            = nByte;
  Info->Heads                = SectorW[3];
  Info->SectorsPerTrack      = SectorW[6];

}
;
