/* ========================================================================
   =================         TVicHW32  DLL             ====================
   =================    Load/Unload   stuff            ====================
   ==========            Shareware Version 5.0                  ===========
   ==========     Copyright (c) 2000 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */

#include <windows.h>
#include "TVicVar.h"

#ifdef __cplusplus
extern "C" {
#endif


InstallDriver(PVicHW32Descriptor HW32, char * ServiceName)
{
    SC_HANDLE	schService;
	char	    ServiceExe[255];
	BOOL        Result;

	GetSystemDirectory(ServiceExe, 128);
	strcat(ServiceExe, "\\DRIVERS\\");
	strcat(ServiceExe, ServiceName);
    strcat(ServiceExe, ".SYS");
	schService = CreateService( 
		                HW32->schSCManager,	    // SCManager database
					    ServiceName,			// name of service
					    ServiceName,			// name to display
					    SERVICE_ALL_ACCESS,		// desired access
					    SERVICE_KERNEL_DRIVER,	// service type
					    SERVICE_DEMAND_START,	// start type
					    SERVICE_ERROR_NORMAL,	// error control type
					    ServiceExe,				// service's binary
						NULL,                   // no load ordering group
						NULL,                   // no tag identifier
						NULL,                   // no dependencies
						NULL,                   // LocalSystem account
						NULL);                  // no password)

    Result = (schService != 0) || (GetLastError() == ERROR_SERVICE_EXISTS);


    CloseServiceHandle(schService);
	return Result;

}

BOOL StartDriver(PVicHW32Descriptor HW32, char * ServiceName) 
{
	
	SC_HANDLE	schService;
	BOOL		Result = FALSE;
    long        Res;
    
	schService = OpenService (HW32->schSCManager, ServiceName, SERVICE_ALL_ACCESS);
	if (schService != 0) {
		
		Result = StartService(schService, 0, NULL);
		Res = GetLastError();

		Result |= (Res == ERROR_SERVICE_ALREADY_RUNNING);


		CloseServiceHandle (schService);

	}
	return Result;
}

BOOL StopDriver(PVicHW32Descriptor HW32, char * ServiceName) 
{
	
	SC_HANDLE schService;
	SERVICE_STATUS serviceStatus;
	BOOL Result = FALSE;

	schService = OpenService (HW32->schSCManager, ServiceName, SERVICE_ALL_ACCESS);
	if (schService != NULL) {
		Result = ControlService (schService, SERVICE_CONTROL_STOP, &serviceStatus);
		CloseServiceHandle (schService);
	}
	return Result;
}

BOOL RemoveDriver(PVicHW32Descriptor HW32, char * ServiceName) 
{

	SC_HANDLE	schService;
	BOOL		Result = FALSE;

	schService = OpenService (HW32->schSCManager, ServiceName, SERVICE_ALL_ACCESS);
	if (schService != 0) {
		Result = DeleteService (schService);
		CloseServiceHandle (schService);
	}
	return Result;
	
}

void CloseStopUnloadDriver(PVicHW32Descriptor HW32, char * ServiceName) 
{
	CloseHandle(HW32->hDrv); 
   if (HW32->fWin95)return;

   if (HW32->fStarted) return;

	HW32->schSCManager = OpenSCManager(0, 0, SC_MANAGER_ALL_ACCESS);

	if  (HW32->schSCManager !=0) {
	// 	StopDriver(HW32,ServiceName);

	//	if (!HW32->fRegistry)

    //	RemoveDriver(HW32,ServiceName);
		CloseServiceHandle(HW32->schSCManager);

    };
}

void InstallStartLoadDriver(PVicHW32Descriptor HW32, char * ServiceName, char * EntryPoint) 
{
  char buffer[255];

//    MessageBox(NULL,ServiceName,"I am in InstallStartLoadDriver",MB_OK);

    if (HW32->fWin95) { // Windows 95/98

//      MessageBox(NULL,ServiceName,"I am in Win98",MB_OK);

     strcpy(buffer,"\\\\.\\");
	 strcat(buffer,ServiceName);
	 strcat(buffer,".VXD");
	 HW32->hDrv   = CreateFile(buffer,
						 0,
						 0,
						 NULL,
						 0,
						 FILE_FLAG_DELETE_ON_CLOSE,
						 0
						 );
/*
	 if (HW32->hDrv != INVALID_HANDLE_VALUE)
		 MessageBox(NULL,ServiceName,"I am in Win98 - success",MB_OK);
	 else
		 MessageBox(NULL,ServiceName,"I am in Win98 - failed",MB_OK);
*/
	 return;
  }; 


  strcpy(buffer,"\\\\.\\");
  strcat(buffer,EntryPoint);
  

  HW32->fRegistry= TRUE; // assume driver already installed
  HW32->fStarted = TRUE; // assume driver already started


  HW32->hDrv     = CreateFile(
     	                buffer, 
	                  	GENERIC_READ | GENERIC_WRITE, 0, NULL,
                        OPEN_EXISTING, 
						FILE_ATTRIBUTE_NORMAL, 
						0
						);

  
  HW32->fLastDebugCode = GetLastError();



  if (HW32->hDrv != INVALID_HANDLE_VALUE) return;




  HW32->fStarted = FALSE;


  HW32->schSCManager = OpenSCManager(0, 0, SC_MANAGER_ALL_ACCESS);


  if (HW32->schSCManager !=0) {


	  // Driver already installed but not started? Try to start...
	  if (StartDriver(HW32, ServiceName)) {

	     HW32->hDrv  = CreateFile(
			                buffer, 
		                  	GENERIC_READ | GENERIC_WRITE, 0, NULL,
                            OPEN_EXISTING, 
							FILE_ATTRIBUTE_NORMAL, 
							0
							);
		    HW32->fLastDebugCode = GetLastError();
			CloseServiceHandle (HW32->schSCManager);

			return; // YES!

          }


		 HW32->fRegistry = FALSE; // not installed

		 
		 if (InstallDriver(HW32, ServiceName)) {


            if (StartDriver(HW32, ServiceName)) {

	           HW32->hDrv   = CreateFile(
			                buffer, 
		                  	GENERIC_READ | GENERIC_WRITE, 0, NULL,
                            OPEN_EXISTING, 
							FILE_ATTRIBUTE_NORMAL, 
							0
							);
			   HW32->fLastDebugCode = GetLastError();
		
			};

		 };

	     CloseServiceHandle (HW32->schSCManager);

	};

	return;

}

#ifdef __cplusplus
 }
#endif
