/* ========================================================================
   =================         TVicHW32  DLL             ====================
   =================    Interrupt     stuff            ====================
   ==========            Shareware Version 5.0                  ===========
   ==========     Copyright (c) 2000 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */

#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <stdio.h>

#include "TVicVar.h"
#include "common.h"
#include "TVicHW32.h"


extern BOOL IsWow64;

//-------------------------------------------------------------

void
__stdcall TheIsr(PVicHW32Descriptor HW32)
{
	
	DWORD	nByte = 0;
	HANDLE  CurrentProcess;
    TOnDelphiInterrupt DelphiHandler;
	ULONG   nIrq;

    //CurrentProcess = GetCurrentProcess();
    // SetPriorityClass(CurrentProcess, REALTIME_PRIORITY_CLASS);
    SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);

	
    SetEvent(HW32->fEventIRQSet);

    while (1)  {

		if (IsWow64)
		{
			nIrq = HW32->fCurrIrqNumber;
			WaitForSingleObject(HW32->f64IrqEvent,INFINITE);
			ResetEvent(HW32->f64IrqEvent);
		}
		else
		{
    		nIrq = WaitForMultipleObjects(16,HW32->fLocEvent,FALSE, INFINITE)  - WAIT_OBJECT_0;
			ResetEvent(HW32->fLocEvent[nIrq]);
		}
		if (!HW32->fTerminated) {

			while ((HW32->fLastHandled[nIrq]) < (HW32->fpLockedMemory->IrqCounterArray[nIrq])) 
			{
				if (HW32->OnHwInterrupt[nIrq]) 
				{
					if (HW32->Components[nIrq]) 
					{
						DelphiHandler = (TOnDelphiInterrupt)(HW32->OnHwInterrupt[nIrq]);
						DelphiHandler(HW32->Components[nIrq], (USHORT)nIrq);
					}
					else
						HW32->OnHwInterrupt[nIrq]((USHORT)nIrq);
				}
		  

				HW32->fLastHandled[nIrq]++;

			}

		}
		else 
			break;
    }

    
    CurrentProcess=GetCurrentProcess();
    SetPriorityClass(CurrentProcess,NORMAL_PRIORITY_CLASS);

}

void  VICFN UnmaskIRQ(PVicHW32Descriptor HW32, USHORT IRQNumber, TOnHWInterrupt HWHandler) 
{

	DWORD   nByte = 0;
	INT_VEC Rec;

	if (HW32             && 
		HW32->fOpenDrive && 
		IRQNumber>0      &&
		IRQNumber<16	 &&
		HW32->fMasked[IRQNumber]) {
		  
		Rec.ClearIrq = 0;

		HW32->fCurrIrqNumber = IRQNumber;

        HW32->fLastHandled[IRQNumber]  = 0;
		HW32->OnHwInterrupt[IRQNumber] = HWHandler;
		HW32->Components[IRQNumber]    = NULL;
		HW32->IrqShared[IRQNumber] = 1;

		Rec.IRQNumber  = IRQNumber;
        Rec.hUserEvent = HW32->fKernelEvent[IRQNumber];
		Rec.pKernelSharedBuffer = HW32->fpInternalLockedMemory;
		Rec.IrqShared = 1;
		HW32->fpLockedMemory->IrqCounterArray[IRQNumber] = 0;

        DeviceIoControl(HW32->hDrv,
                        CtlCode(UNMASK_INT_VEC),
                        &Rec,sizeof(Rec),NULL,0,
                        &nByte,NULL);

        HW32->fMasked[IRQNumber] = FALSE;
 	
	};

}

void  VICFN UnmaskIRQEx(PVicHW32Descriptor HW32, 
						USHORT IRQNumber, 
						ULONG  IrqShared,
						TOnHWInterrupt HWHandler,
						pIrqClearRec IrqRec) 
{

	DWORD   nByte = 0;
	INT_VEC Rec;

	if (HW32             && 
		HW32->fOpenDrive && 
		IRQNumber>0      &&
		IRQNumber<16	 &&
		HW32->fMasked[IRQNumber]) {

		Rec.ClearIrq = IrqRec->ClearIrq;
        Rec.ReadOrWrite = IrqRec->ReadOrWrite;
        Rec.RegBaseAddress = IrqRec->RegBaseAddress;
        Rec.RegOffset = IrqRec->RegOffset;
        Rec.TypeOfRegister = IrqRec->TypeOfRegister;
		Rec.ValueToWrite = IrqRec->ValueToWrite;
		Rec.WideOfRegister = IrqRec->WideOfRegister;

		HW32->fCurrIrqNumber = IRQNumber;

        HW32->fLastHandled[IRQNumber]  = 0;
		HW32->OnHwInterrupt[IRQNumber] = (TOnHWInterrupt)HWHandler;
		HW32->Components[IRQNumber]    = NULL;
		HW32->IrqShared[IRQNumber] = IrqShared;

		Rec.IRQNumber  = IRQNumber;
        Rec.hUserEvent = HW32->fKernelEvent[IRQNumber];
		Rec.pKernelSharedBuffer = HW32->fpInternalLockedMemory;
		Rec.IrqShared = IrqShared;
		HW32->fpLockedMemory->IrqCounterArray[IRQNumber] = 0;

        DeviceIoControl(HW32->hDrv,
                        CtlCode(UNMASK_INT_VEC),
                        &Rec,sizeof(Rec),&Rec,sizeof(Rec),
                        &nByte,NULL);

		IrqRec->ClearIrq = Rec.ClearIrq;
        IrqRec->ReadOrWrite = Rec.ReadOrWrite;
        IrqRec->RegBaseAddress = Rec.RegBaseAddress;
        IrqRec->RegOffset = Rec.RegOffset;
        IrqRec->TypeOfRegister = Rec.TypeOfRegister;
		IrqRec->ValueToWrite = Rec.ValueToWrite;
		IrqRec->WideOfRegister = Rec.WideOfRegister;

        HW32->fMasked[IRQNumber] = FALSE;
 	
	};

}


void    VICFN UnmaskDelphiIRQ(PVicHW32Descriptor HW32, HANDLE Component, USHORT IRQNumber, TOnHWInterrupt HWHandler)
{
    DWORD   nByte = 0;
	INT_VEC Rec;

	if (HW32             && 
		HW32->fOpenDrive && 
		IRQNumber>0      &&
		IRQNumber<16	 &&
		HW32->fMasked[IRQNumber]) {
		  
		Rec.ClearIrq = 0;

		HW32->fCurrIrqNumber = IRQNumber;

        HW32->fLastHandled[IRQNumber]  = 0;
		HW32->OnHwInterrupt[IRQNumber] = HWHandler;
		HW32->Components[IRQNumber]    = Component;
		HW32->IrqShared[IRQNumber] = 1;

		Rec.IRQNumber  = IRQNumber;
        Rec.hUserEvent = HW32->fKernelEvent[IRQNumber];
		Rec.pKernelSharedBuffer = HW32->fpInternalLockedMemory;
		Rec.IrqShared  = 1;

        DeviceIoControl(HW32->hDrv,
                        CtlCode(UNMASK_INT_VEC),
                        &Rec,sizeof(Rec),NULL,0,
                        &nByte,NULL);

        HW32->fMasked[IRQNumber] = FALSE;
 	
	};

}

void    VICFN UnmaskDelphiIRQEx(PVicHW32Descriptor HW32, 
								HANDLE Component, 
								USHORT IRQNumber, 
								ULONG  IrqShared,
								TOnHWInterrupt HWHandler,
								pIrqClearRec IrqRec)
{
    DWORD   nByte = 0;
	INT_VEC Rec;

	if (HW32             && 
		HW32->fOpenDrive && 
		IRQNumber>0      &&
		IRQNumber<16	 &&
		HW32->fMasked[IRQNumber]) {


        HW32->fLastHandled[IRQNumber]  = 0;
		HW32->OnHwInterrupt[IRQNumber] = (TOnHWInterrupt)HWHandler;
		HW32->Components[IRQNumber]    = Component;
		HW32->IrqShared[IRQNumber] = IrqShared;

		HW32->fCurrIrqNumber = IRQNumber;

		Rec.IRQNumber  = IRQNumber;
        Rec.hUserEvent = HW32->fKernelEvent[IRQNumber];
		Rec.pKernelSharedBuffer = HW32->fpInternalLockedMemory;
		Rec.IrqShared  = IrqShared;

	    Rec.ClearIrq = IrqRec->ClearIrq;
        Rec.ReadOrWrite = IrqRec->ReadOrWrite;
        Rec.RegBaseAddress = IrqRec->RegBaseAddress;
        Rec.RegOffset = IrqRec->RegOffset;
        Rec.TypeOfRegister = IrqRec->TypeOfRegister;
		Rec.ValueToWrite = IrqRec->ValueToWrite;
		Rec.WideOfRegister = IrqRec->WideOfRegister;


        DeviceIoControl(HW32->hDrv,
                        CtlCode(UNMASK_INT_VEC),
                        &Rec,sizeof(Rec),NULL,0,
                        &nByte,NULL);

        HW32->fMasked[IRQNumber] = FALSE;
 	
	};

}


ULONG  VICFN MaskIRQ(PVicHW32Descriptor HW32, USHORT IRQNumber) 
{
	
	ULONG nByte = 0, Counter = 0;

	if (HW32 && HW32->fOpenDrive && !(HW32->fMasked[IRQNumber])) {

                if (HW32->LptIrqForced) ForceIrqLPT(HW32, FALSE);

      	        HW32->fMasked[IRQNumber] = TRUE;

                DeviceIoControl(HW32->hDrv,
				    	        CtlCode(MASK_INT_VEC),
					            &IRQNumber, 2, &Counter, 4,
					            &nByte, NULL);			              	            

	            HW32->Components[IRQNumber] = NULL;
				HW32->IrqShared[IRQNumber] = 1;
	}
	return Counter;
}
ULONG  VICFN GetIRQCounter(PVicHW32Descriptor HW32, USHORT IRQNumber) 
{

	ULONG nByte = 0, Counter = 0;

	if (HW32 && HW32->fOpenDrive) {
		
		if (!HW32->fMasked[IRQNumber]) {

      	        DeviceIoControl(HW32->hDrv,
				    	        CtlCode(GET_IRQ_COUNTER),
					            &IRQNumber, 2, &Counter, 4,
					            &nByte, NULL);
		}
		else
			Counter = HW32->fLastHandled[IRQNumber];
	
	}
	return Counter;
}

BOOL  VICFN IsIRQMasked(PVicHW32Descriptor HW32, USHORT IRQNumber ) 
{
	if (HW32 && HW32->fOpenDrive)
	    return HW32->fMasked[IRQNumber];
	else
		return TRUE;
}

