/* ========================================================================
   =================         TVicHW32  DLL             ====================
   =================      Keyboard     stuff           ====================
   ==========            Shareware Version 5.0                  ===========
   ==========     Copyright (c) 2000 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */


#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <stdio.h>

#include "TVicVar.h"
#include "common.h"
#include "TVicHW32.h"


void VICFN PutScanCode(PVicHW32Descriptor HW32, UCHAR b)
{

DWORD sc_code,nByte;

  if ((!HW32) || (!HW32->fOpenDrive) ) return;
  
  sc_code = b;
  DeviceIoControl(HW32->hDrv,
                  CtlCode(PUT_SCAN_CODE),
                  &sc_code,4,NULL,0,
                  &nByte,NULL);
}	

WORD VICFN GetScanCode(PVicHW32Descriptor HW32)
{
  if ((!HW32) || (!HW32->fOpenDrive) ) 
	  return 0;
  else 
      return *(WORD *)(HW32->fpLockedMemory);

 }	


static KEYBOARD_INPUT_DATA KbdData[FIFOSIZE];

void __stdcall KbdProcHandler(PVicHW32Descriptor HW32)
{
	
    ULONG               nByte,i,NumItems;
    UCHAR               scan_code;
    TKbDelphiHandler    DelphiHookHandler;

    
    nByte = 0;
 
    DeviceIoControl(HW32->hDrv,
                    CtlCode(HOOK_KEYBOARD),
                    &(HW32->fHookKernelEvent),4,NULL,0,
                    &nByte,NULL);

    SetEvent(HW32->fEventIRQSet);

	HW32->fHookReason = 0;

    while (1) {
    
      WaitForSingleObject(HW32->fHookLocEvent,INFINITE);

      ResetEvent(HW32->fHookLocEvent);

      if (!HW32->fHookTerminated) {

		  switch (HW32->fHookReason) {
			      
		  case 0:     // real keyboard hook

			  if (HW32->fWin95) {

				  DeviceIoControl(HW32->hDrv,
					              CtlCode(READ_KEYBOARD),
                                  NULL,0,&scan_code,1,
                                  &nByte,NULL);

				  if (HW32->fOnKeystroke) {
					  if (HW32->fHookComponent){
                         DelphiHookHandler = (TKbDelphiHandler)(HW32->fOnKeystroke);
					     DelphiHookHandler(HW32->fHookComponent,scan_code);
					  }
					  else
						 HW32->fOnKeystroke(scan_code);
				  }
			  }
              else {

				  ReadFile(HW32->hDrv,
                           KbdData,
                           sizeof(KbdData),
                           &nByte,NULL);

                  NumItems  =  nByte / sizeof(KEYBOARD_INPUT_DATA);

                  for (i=0; i<NumItems; i++){

					  if (HW32->fOnKeystroke) {

						  scan_code  =  (UCHAR)(KbdData[i].MakeCode);
                          if (KbdData[i].Flags & 1) 
							  scan_code  |=  0x80;

                  if (HW32->fOnKeystroke) {
					  if (HW32->fHookComponent){
                         DelphiHookHandler = (TKbDelphiHandler)(HW32->fOnKeystroke);
					     DelphiHookHandler(HW32->fHookComponent,scan_code);
					  }
					  else
						 HW32->fOnKeystroke(scan_code);
				  }
				
					  }
				  }

			      HW32->fHookReason = 0;
			  }
              
			  
              //if (HW32->fOnKeystroke) 
			//	   HW32->fOnKeystroke((BYTE)GetScanCode(HW32));

			  break;

		  case 1:        // test hook via driver
                  if (HW32->fOnKeystroke) {
					  if (HW32->fHookComponent){
                         DelphiHookHandler = (TKbDelphiHandler)(HW32->fOnKeystroke);
					     DelphiHookHandler(HW32->fHookComponent,0x77);
					  }
					  else
						 HW32->fOnKeystroke(0x77);
				  }

                  break;
		  
		  case 2:        // local test hook
			     if (HW32->fOnKeystroke) {
					  if (HW32->fHookComponent){
                         DelphiHookHandler = (TKbDelphiHandler)(HW32->fOnKeystroke);
					     DelphiHookHandler(HW32->fHookComponent,0x55);
					  }
					  else
						 HW32->fOnKeystroke(0x55);
				  }
			  
			      break;

		  }

		  HW32->fHookReason = 0;
      }
      else
        break;
    }

    DeviceIoControl(HW32->hDrv,
                    CtlCode(UNHOOK_KEYBOARD),
                    NULL,0,NULL,0,
                    &nByte,NULL);

}

void VICFN HookKeyboard(PVicHW32Descriptor HW32, TKbHookHandler HWHandler)
{
	if ( HW32 && HW32->fOpenDrive){

		HW32->fOnKeystroke = HWHandler;
		HW32->fEventIRQSet = CreateEvent(NULL,TRUE,FALSE,NULL);
        ResetEvent(HW32->fEventIRQSet);
        HW32->fHookTerminated = FALSE;
		HW32->fHookComponent  = NULL;

        HW32->fHookThreadHandle = CreateThread(NULL,
			                                   0,
											   (LPTHREAD_START_ROUTINE)&KbdProcHandler,
											   HW32,
											   0,
											   (LPDWORD)&(HW32->fHookThreadId));

        WaitForSingleObject(HW32->fEventIRQSet,INFINITE);
        HW32->fHooked = TRUE;
        CloseHandle(HW32->fEventIRQSet);
	}
}

void VICFN HookDelphiKeyboard(PVicHW32Descriptor HW32, HANDLE Component, TKbHookHandler HWHandler)
{
	if ( HW32 && HW32->fOpenDrive){

		HW32->fOnKeystroke = HWHandler;
		HW32->fEventIRQSet = CreateEvent(NULL,TRUE,FALSE,NULL);
        ResetEvent(HW32->fEventIRQSet);
        HW32->fHookTerminated = FALSE;
		HW32->fHookComponent  = Component;

        HW32->fHookThreadHandle = CreateThread(NULL,
			                                   0,
											   (LPTHREAD_START_ROUTINE)&KbdProcHandler,
											   HW32,
											   0,
											   (LPDWORD)&(HW32->fHookThreadId));

        WaitForSingleObject(HW32->fEventIRQSet,INFINITE);
        HW32->fHooked = TRUE;
        CloseHandle(HW32->fEventIRQSet);
	}
}


void VICFN UnhookKeyboard(PVicHW32Descriptor HW32)
{
	if ( HW32 && HW32->fOpenDrive){

		HW32->fHookTerminated = TRUE;
        SetEvent(HW32->fHookLocEvent);
        WaitForSingleObject(HW32->fHookThreadHandle,INFINITE);

	}

    HW32->fHooked = FALSE;
	HW32->fHookComponent  = NULL;
}

void VICFN PulseKeyboard(PVicHW32Descriptor HW32)
{

DWORD nByte = 0;

  if ((!HW32) || (!HW32->fOpenDrive) ) return;
  
  HW32->fHookReason = 1;


  DeviceIoControl(HW32->hDrv,
                  CtlCode(PULSE_KEYBOARD),
                  NULL,0,NULL,0,
                  &nByte,NULL);
}	

void VICFN PulseKeyboardLocal(PVicHW32Descriptor HW32)
{

  
  if ((!HW32) || (!HW32->fOpenDrive) ) return;

  HW32->fHookReason = 2;

  PulseEvent(HW32->fHookLocEvent);

}	
