/* ========================================================================
   =================         TVicHW32  DLL             ====================
   =================        Memory    stuff            ====================
   ==========            Shareware Version 5.0                  ===========
   ==========     Copyright (c) 2000 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */


#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <stdio.h>

#include "TVicVar.h"
#include "common.h"
#include "TVicHW32.h"

extern ULONG CtlCode(ULONG Code);


void VICFN UnmapMemory(PVicHW32Descriptor HW32,ULONG PhAddr, ULONG PhSize) 
{

    ULONG	nByte;
	int i,j;

    if ((!HW32) || (!HW32->fOpenDrive) ) return;
    

    for (i=0; i<HW32->fMappedAreas; i++) {

		if ((ULONG)PhAddr == (ULONG)HW32->fMappedAddresses[i]) {

		 	DeviceIoControl(HW32->hDrv,
		    				CtlCode(UNMAP_MEMORY),
			    			&HW32->fMappedPointers[i], 4,
				    		NULL, 0, &nByte, NULL);
			for (j=i; j<(HW32->fMappedAreas-1); j++) {
				HW32->fMappedPointers[j] = HW32->fMappedPointers[j+1];
                HW32->fMappedAddresses[j] = HW32->fMappedAddresses[j+1];
				HW32->fMappedSizes[j] = HW32->fMappedSizes[j+1];
            };
			--HW32->fMappedAreas;
                        return;
		};
	};
}


ULONG VICFN MapPhysToLinear(PVicHW32Descriptor HW32,ULONG PhAddr, ULONG PhSize) 
{

	ULONG MP,nByte = 0;
	int   i;
	
	if ((!HW32) || (!HW32->fOpenDrive) ) return 0;
	
	for (i=0; i<HW32->fMappedAreas; i++) {
			
		if ( (ULONG)PhAddr == (ULONG)HW32->fMappedAddresses[i])
		  return (ULONG)HW32->fMappedPointers[i];
	};

	if (HW32->fMappedAreas == MaxMappedAreas) return 0;
	HW32->fMemorySize = (ULONG)PhSize;
	HW32->fPhysLoPart = (ULONG)PhAddr;
	DeviceIoControl(HW32->hDrv,
					CtlCode(MAP_MEMORY),
					&HW32->fInterface, 24,
					&MP, 4,
                    &nByte, NULL);
    HW32->fMappedSizes[HW32->fMappedAreas] = PhSize;
	HW32->fMappedPointers[HW32->fMappedAreas] = (PVOID)MP;
	HW32->fMappedAddresses[HW32->fMappedAreas] = PhAddr;
	HW32->fMappedAreas++;
	
	return MP;

}


UCHAR VICFN GetMem(PVicHW32Descriptor HW32,ULONG MappedAddr, ULONG Offset) 
{

    if ((!HW32) || (!HW32->fOpenDrive) ) return 0;   
	
	return *(PUCHAR)(MappedAddr+Offset);
}

void VICFN SetMem(PVicHW32Descriptor HW32,ULONG MappedAddr, ULONG Offset, UCHAR nNewValue) 
{
	if (!HW32) return;   
    if ((!HW32->fOpenDrive) || (MappedAddr<100)) return;
		
    *(PUCHAR)(MappedAddr+Offset) = nNewValue;

}

USHORT VICFN GetMemW(PVicHW32Descriptor HW32,ULONG MappedAddr, ULONG Offset) 
{
	if (!HW32) return 0;   
	if ((!HW32->fOpenDrive) || (MappedAddr<100)) return 0;
		
	return *(PUSHORT)(MappedAddr+Offset);
	
}

void VICFN SetMemW(PVicHW32Descriptor HW32,ULONG MappedAddr, ULONG Offset, USHORT nNewValue) 
{
    if (!HW32) return;   
	if ((!HW32->fOpenDrive) || (MappedAddr<100)) return;

    *(PUSHORT)(MappedAddr+Offset) = (USHORT)nNewValue;
}

ULONG VICFN GetMemL(PVicHW32Descriptor HW32,	ULONG MappedAddr, ULONG Offset) 
{
	if (!HW32) return 0;   
	if ((!HW32->fOpenDrive) || (MappedAddr<100)) return 0;

	return (ULONG)*(PULONG)(MappedAddr+Offset);
	
}

void VICFN SetMemL(PVicHW32Descriptor HW32,ULONG MappedAddr, ULONG Offset, ULONG nNewValue) 
{
	if (!HW32) return;   
	if ((!HW32->fOpenDrive) || (MappedAddr<100)) return;

    *(PULONG)(MappedAddr+Offset) = (ULONG)nNewValue;

	
}

short VICFN GetMappedAreas(PVicHW32Descriptor HW32) 
{
	if ((!HW32) || (!HW32->fOpenDrive) ) return 0;
	return HW32->fMappedAreas;
}

PVOID   VICFN GetLockedMemory(PVicHW32Descriptor HW32)
{
	if ((!HW32) || (!HW32->fOpenDrive) ) return NULL;
	return HW32->fpLockedMemory;
}

ULONG   VICFN GetTempVar(PVicHW32Descriptor HW32)
{
	if ((!HW32) || (!HW32->fOpenDrive) ) return 0;
	return HW32->fpLockedMemory->TempVar;
}
