/* ========================================================================
   =================         TVicHW32  DLL             ====================
   =================   PCI hardware information        ====================
   ==========            Shareware Version 5.0                  ===========
   ==========     Copyright (c) 2000 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */

#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <stdio.h>

#include "TVicVar.h"
#include "common.h"
#include "TVicHW32.h"

USHORT VICFN GetLastPciBus(PVicHW32Descriptor HW32)
{
	DWORD orig, d;
	BOOL  SaveState;
	if ((!HW32) || (!HW32->fOpenDrive) ) return 0;

	SaveState = HW32->fHardAccess;

	HW32->fHardAccess = TRUE;
	orig = GetPortLong(HW32,0xCF8); // save original address
	SetPortLong(HW32,0xCF8,0x80000000);

    d = GetPortLong(HW32,0xCFC);

	SetPortLong(HW32,0xCF8,orig); // restore original address

	return (USHORT)(d & 0x0000000F);

}

USHORT VICFN GetHardwareMechanism(PVicHW32Descriptor HW32)
{
	return 1;
}


BOOL VICFN GetPciDeviceInfo(PVicHW32Descriptor HW32, 
							USHORT             BusNum,
							USHORT             DeviceNum,
							USHORT             FuncNum,
							PPCI_COMMON_CONFIG pPciCfg)
{

  DWORD orig,dwaddress,i;
  BOOL  SaveState;
  DWORD * OutBuf;
  DWORD headtype;

  if ((!HW32) || (!HW32->fOpenDrive) ) return FALSE;

  SaveState = HW32->fHardAccess;

  HW32->fHardAccess = TRUE;


  if (FuncNum > 0) {

  // determine if the current slot is single function device

       orig = GetPortLong(HW32,0xCF8); // save original address

       dwaddress =((ULONG)0x80000000) |
		          ((ULONG)(BusNum & 0xFF) << 16) |
				  ((ULONG)(DeviceNum & 0x1F) << 11) |
				  ((ULONG)12);

	   SetPortLong(HW32,0xCF8,dwaddress);

       headtype = GetPortLong(HW32,0xCFC);

	   SetPortLong(HW32,0xCF8,orig); // restore original address

	   if (DeviceNum == 4)
	      HW32->fLastDebugCode = headtype;

	   if ( (headtype & 0x00800000) == 0 )
	   {
           pPciCfg->VendorID = 0xFFFF;
		   pPciCfg->DeviceID = 0xFFFF;
		   return FALSE;
	   }

  }



  OutBuf = (DWORD*) pPciCfg;

  orig = GetPortLong(HW32,0xCF8); // save original address

  for (i = 0; i<64; i++) {




      dwaddress = ((ULONG)0x80000000) |
		          ((DWORD)(BusNum & 0x0F) << 16) |
				  ((DWORD)(DeviceNum & 0x1F) << 11) |
				  ((DWORD)(FuncNum & 0x07) << 8)|
				  ((DWORD)(i*4) & 0xFC);

	   SetPortLong(HW32,0xCF8,dwaddress);


       *(OutBuf+i) = GetPortLong(HW32,0xCFC);





       if ((i == 0) &&
		   ((pPciCfg->VendorID == 0xFFFF) &&
		   (pPciCfg->DeviceID == 0xFFFF))) {
          SetPortLong(HW32,0xCF8,orig); // restore original address
          return FALSE;
	   }

  }

  SetPortLong(HW32,0xCF8,orig); // restore original address

  HW32->fHardAccess = SaveState;



  return TRUE;

}


BOOL   VICFN GetPciHeader( PVicHW32Descriptor  HW32,
						   ULONG               VendorId,
				           ULONG               DeviceId,
				           ULONG               OffsetInBytes,
				           ULONG               LengthInBytes,
	    			       PPCI_COMMON_CONFIG  pPciCfg)
{
			               

  DWORD nBytes = 0;
  

  if (!HW32 || !HW32->fOpenDrive) return FALSE;

    
    pPciCfg->VendorID = (USHORT)VendorId;
    pPciCfg->DeviceID = (USHORT)DeviceId;
    pPciCfg->DeviceSpecific[190] = (BYTE)OffsetInBytes;
    pPciCfg->DeviceSpecific[191] = (BYTE)LengthInBytes;

    HW32->fLastDebugCode = 456;


    DeviceIoControl(HW32->hDrv,
                  CtlCode(PCI_READ_HEADER),
                  pPciCfg,256,
                  pPciCfg,256,
                  &nBytes,
                  NULL);

	HW32->fLastDebugCode = 789;

  return (nBytes!=0);


}

BOOL   VICFN SetPciHeader( PVicHW32Descriptor  HW32,
						   ULONG               VendorId,
				           ULONG               DeviceId,
				           ULONG               OffsetInBytes,
				           ULONG               LengthInBytes,
	    			       PPCI_COMMON_CONFIG  pPciCfg)
			               
{
	DWORD nBytes = 0;
  

  if (!HW32 || !HW32->fOpenDrive) return FALSE;

    pPciCfg->VendorID = (USHORT)VendorId;
    pPciCfg->DeviceID = (USHORT)DeviceId;
	pPciCfg->DeviceSpecific[190] = (BYTE)OffsetInBytes;
    pPciCfg->DeviceSpecific[191] = (BYTE)LengthInBytes;


    DeviceIoControl(HW32->hDrv,
                  CtlCode(PCI_WRITE_HEADER),
                  pPciCfg,256,
                  pPciCfg,256,
                  &nBytes,
                  NULL);

  return (nBytes!=0);

}



