/* ========================================================================
   =================    TVicHW32  DLL main module      ====================
   ==========            Shareware Version 4.0                  ===========
   ==========     Copyright (c) 1999 Victor I.Ishikeev          ===========
   ========================================================================
   ==========         mail to "tools@entechtaiwan.com"          ===========
   ======================================================================== */

#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <stdio.h>

#include "TVicVar.h"
#include "common.h"
#include "TVicHW32.h"

static DWORD MainDebugCode = 777;


#pragma data_seg("Shared")
static TVicHW32Descriptor HW32_STRUCT[8];
DWORD InstanceOpened[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
#pragma data_seg()

static int LocalInstance=77;
static PVicHW32Descriptor pHW32;
typedef BOOL   (__stdcall * TIsWow64)(HANDLE hProcess, BOOL * Wow64Process);
BOOL IsWow64 = FALSE;

void
__stdcall TheIsr(PVicHW32Descriptor HW32);

//-------------------------------------------------------------
ULONG CtlCode(ULONG Code) 
{
  if (!(GetVersion() & 0x80000000))	
	  return Code;
  else   		
	  return ((Code>>2)&0x000000ff);
}

int TimerResolution(HANDLE hDrv);


ULONG VICFN GetLocalInstance()
{
	return LocalInstance;
}


//=============================================
HANDLE  VICFN CloseTVicHW32(PVicHW32Descriptor HW32) 
{
	if (pHW32 && pHW32->fOpenDrive) {
		pHW32->fTerminated = 1;

		if (IsWow64)
			SetEvent(pHW32->f64IrqEvent);
		else
			SetEvent(pHW32->fLocEvent[0]);
				
        WaitForSingleObject(pHW32->fThreadHandle,INFINITE);
	    CloseHandle(pHW32->fThreadHandle);
	}

	return NULL;
}

//=============================================
HANDLE  VICFN OpenTVicHW() 
{



	if (pHW32 && pHW32->fOpenDrive) {


		if (TimerResolution(pHW32->hDrv)==0) return NULL;
			
		
		pHW32->fEventIRQSet  = CreateEvent(NULL,TRUE,FALSE,NULL);
	    pHW32->fTerminated   = 0;
        ResetEvent(pHW32->fEventIRQSet);

        pHW32->fThreadHandle = CreateThread(NULL,
  			 			                   0,
							               (LPTHREAD_START_ROUTINE)&TheIsr,
							               pHW32,
							               0,
							               (LPDWORD)&(pHW32->fThreadId));
			
		
        WaitForSingleObject(pHW32->fEventIRQSet,INFINITE);
   
        CloseHandle(pHW32->fEventIRQSet);



	}

   return pHW32;
}

//=============================================
HANDLE  VICFN OpenTVicHW32(PVicHW32Descriptor HW32, 
						   char * ServiceName,
						   char * EntryPoint) 
{
	return OpenTVicHW();
}


//=============================================
void CloseTVic() 
{

    ULONG nByte;
	USHORT i;
	PVicHW32Descriptor HW32;

	MainDebugCode = 8;
	HW32 = pHW32;


	if (HW32->fHooked) {
		UnhookKeyboard(HW32);
		HW32->fHooked = FALSE;
	}



	for (i=0; i<3; i++) {

		if (HW32->fLptAcquired[i] == LPT_ACQUIRE_SUCCESS) {

			ReleaseLPT(HW32,(USHORT)(i+1));
		}

		HW32->fLptAcquired[i] = LPT_NOT_ACQUIRED;
	}

	HW32->fHookComponent  = NULL;

	HW32->fHardAccess = TRUE;
	for (i=0; i<16; i++)
	{
	  if (!HW32->fMasked[i]) MaskIRQ(HW32,i);
	  HW32->Components[i] = NULL;
	  HW32->IrqShared[i] = 1;
	}

	if (IsWow64)
	{
		CloseHandle(HW32->f64IrqEvent);
        CloseHandle(HW32->f64HookEvent);
	}

	else
	{
	
		for (i=0; i<16; i++) {
			CloseHandle(HW32->fLocEvent[i]);
			HW32->fLocEvent[i] = 0;
		}

		CloseHandle(HW32->fHookLocEvent);
	}

	DeviceIoControl(HW32->hDrv,
		          CtlCode(UNLOCK_MEMORY),
				  &HW32->fpLockedMemory,4,
				  &HW32->fpLockedMemory,4,
				  &nByte,NULL);
	for ( i=0; i<HW32->fMappedAreas; i++)
		UnmapMemory(HW32,(ULONG)HW32->fMappedPointers[i],HW32->fMappedSizes[i]);

	DestroyRing0Call(HW32);
  
	CloseStopUnloadDriver(HW32,HW32->fServiceName);

	HW32->fOpenDrive = FALSE;
    

}

BOOL OpenTVic() 
{

  OSVERSIONINFOA  WinVer;
  ULONG           nByte;
  short           i;
  WORD          * MappedLPTArea;
  LockedBuffer    Rec;
  PVicHW32Descriptor HW32;
  char            EntryPoint[256];
  char            IrqEventName[256];

  

  MainDebugCode = 1;
  HW32 = pHW32;
  

  memset(HW32, 0, sizeof(TVicHW32Descriptor));

  MainDebugCode = 2;
  HW32->DriverInstance = LocalInstance;
  HW32->IsTimerSet = FALSE;
    
  

  HW32->fWin95  = (GetVersion() & 0x80000000)!=0;


  HW32->fBiosMethod = 0;

  strcpy(HW32->fServiceName,OpenDriverName);
  
  sprintf(EntryPoint,"%s%d",OpenEntryPoint,LocalInstance);

  
  HW32->fOpenDrive     = FALSE;

  for (i = 0; i<16; i++) 
  {
	  HW32->fMasked[i] = TRUE;
	  HW32->Components[i] = NULL;
	  HW32->IrqShared[i] = 1;
  }

  for ( i = 0; i<3; i++) HW32->fLptAcquired[i] = LPT_NOT_ACQUIRED;

  HW32->fHookComponent  = NULL;

  HW32->fHooked        = FALSE;
  HW32->fMemoryMapped  = FALSE;
  HW32->fHardAccess    = TRUE;
  HW32->fInterface     = 1;        // Isa, Eisa, etc....
  HW32->fBus           = 0;        // Bus number
  HW32->fPhysLoPart    = 0;        // Bus-relative address
  HW32->fPhysHiPart    = 0;
  HW32->fTypeMem       = 0;        // 0 is memory, 1 is I/O
  HW32->fMemorySize    = 0;        // Length of section to map

  HW32->hDrv           = INVALID_HANDLE_VALUE;

  HW32->fLPTs         = 0;
  HW32->fLPTBasePort  = 0x378;
  HW32->fLPTNumber    = 1;

  	
//  MessageBox(NULL,EntryPoint,OpenDriverName,MB_OK);
  
  InstallStartLoadDriver(HW32, OpenDriverName, EntryPoint);
  	                                 

  if (HW32->fOpenDrive = (HW32->hDrv != INVALID_HANDLE_VALUE)) {


	  if (IsWow64) {

		   sprintf(IrqEventName,"HW64IrqEvent%d",LocalInstance);
           HW32->f64IrqEvent = CreateEvent(NULL,TRUE,FALSE,IrqEventName);

           sprintf(IrqEventName,"HW64KbdEvent%d",LocalInstance);
           HW32->f64HookEvent=CreateEvent(NULL,TRUE,FALSE,IrqEventName);
	  }
	  else
	  {  

		for (i = 0; i<16; i++) HW32->fLocEvent[i] = CreateEvent(NULL,TRUE,FALSE,NULL);
		HW32->fHookLocEvent=CreateEvent(NULL,TRUE,FALSE,NULL);

	  }

	  if (!(HW32->fWin95)) {
  
          WinVer.dwOSVersionInfoSize = sizeof(WinVer);
          GetVersionEx(&WinVer);
          HW32->fNT5 = WinVer.dwMajorVersion>4;
		  if (!IsWow64)
		  {
			for (i = 0; i<16; i++) 
				HW32->fKernelEvent[i] = HW32->fLocEvent[i];
			HW32->fHookKernelEvent = HW32->fHookLocEvent;
		  }
	  }
      else {

		  HW32->fNT5               = 0;

          HW32->hDll               = GetModuleHandle("kernel32");
          HW32->fOpenVxDHandle     = (TOpenVxDHandle)GetProcAddress(HW32->hDll,"OpenVxDHandle");

	      for (i = 0; i<16; i++) 
		     HW32->fKernelEvent[i] = HW32->fOpenVxDHandle(HW32->fLocEvent[i]);

          HW32->fHookKernelEvent   = HW32->fOpenVxDHandle(HW32->fHookLocEvent);

	  };


// Prepare Ring0 calls
      HW32->fCallGateCreated = FALSE;
// Create thread for the interrupts hanling (See OpenTVicHW32!!!!)
//----------------------------------------------------------------

	  
      HW32->fPhysLoPart = 0x408;
	  HW32->fMemorySize = 6;

	  DeviceIoControl(HW32->hDrv,
		              CtlCode(MAP_MEMORY),
					  &(HW32->fInterface),24,
					  &MappedLPTArea,4,
					  &nByte,NULL);
      HW32->hDll = (HINSTANCE)HW32->fLPTAddresses;



	  if (((ULONG)MappedLPTArea != 0) && ((ULONG)MappedLPTArea != 0xFFFFFFFF)) {

	    for ( i = 0; i<3; i++) {

		  __try {
			  if ((*(MappedLPTArea+i)) !=0) {
				  
                  HW32->fLPTAddresses[HW32->fLPTs++] = *(MappedLPTArea+i);
			  }
		  }
		  __finally {}
		}
	  }
	  else {

		  HW32->fLPTs = 1;

		  HW32->fLPTAddresses[0] = 0x378;

	  }

	  HW32->fLPTBasePort = HW32->fLPTAddresses[0];
	  HW32->fLPTNumber = 1;

	  HW32->LptIrqForced = 0;

	  
      Rec.NumLockedPages   = 2;
	  Rec.BufferSize       = Rec.NumLockedPages * 4096;

      DeviceIoControl(HW32->hDrv,
                      CtlCode(LOCK_MEMORY),
                      &Rec,sizeof(Rec),&Rec,sizeof(Rec),
                      &nByte,NULL); 

	  HW32->fpLockedMemory = (pSharedBuffer)Rec.pB.pUBuf[0];
      HW32->fpInternalLockedMemory = (pSharedBuffer)Rec.pLA.pUInternalLockedAddress[0];

	  

	  return TRUE;


  }
  else {

      nByte = HW32->fLastDebugCode;
	  return FALSE;

  }

}


BOOL VICFN GetActiveHW(PVicHW32Descriptor HW32) 
{
	if (HW32==NULL) return FALSE;
	return HW32->fOpenDrive;
}


ULONG VICFN DebugCode(PVicHW32Descriptor HW32) 
{

	return MainDebugCode;
}



BOOL  VICFN GetSysDmaBuffer( PVicHW32Descriptor  HW32,
	 					     PDMA_BUFFER_REQUEST BufReq)
{

    ULONG nByte;

	BufReq->LinDmaAddress  = 0;
    BufReq->PhysDmaAddress = 0;
	BufReq->PMemHandle     = 0;

	if ((!HW32) || (!HW32->fOpenDrive) ) return FALSE;

    DeviceIoControl(HW32->hDrv,
                    CtlCode(SYS_DMA_BUFFER),
                    BufReq,sizeof(DMA_BUFFER_REQUEST),
					BufReq,sizeof(DMA_BUFFER_REQUEST),
                    &nByte,NULL); 
    
	return (BufReq->LinDmaAddress) != 0;

}

BOOL  VICFN GetBusmasterDmaBuffer( PVicHW32Descriptor  HW32,
	 					           PDMA_BUFFER_REQUEST BufReq)
{

	
    ULONG nByte;

	BufReq->LinDmaAddress  = 0;
    BufReq->PhysDmaAddress = 0;
	BufReq->PMemHandle     = 0;

	
    if ((!HW32) || (!HW32->fOpenDrive) ) return FALSE;

    DeviceIoControl(HW32->hDrv,
                    CtlCode(PCI_DMA_BUFFER),
                    BufReq,sizeof(DMA_BUFFER_REQUEST),
					BufReq,sizeof(DMA_BUFFER_REQUEST),
                    &nByte,NULL); 
    
	return (BufReq->LinDmaAddress) != 0;
}

void  VICFN FreeDmaBuffer( PVicHW32Descriptor  HW32,
	 			    	   PDMA_BUFFER_REQUEST BufReq)
{
	
    ULONG nByte;

    if ((!HW32) || (!HW32->fOpenDrive) ) return;

    DeviceIoControl(HW32->hDrv,
                    CtlCode(FREE_DMA_BUFFER),
                    BufReq,sizeof(DMA_BUFFER_REQUEST),
					BufReq,sizeof(DMA_BUFFER_REQUEST),
                    &nByte,NULL); 

    BufReq->LinDmaAddress  = 0;
    BufReq->PhysDmaAddress = 0;
	BufReq->PMemHandle     = 0;

	return;
}


void  VICFN GetMsrValue(PVicHW32Descriptor HW32, ULONG RegNumber, PMSR_DATA MsrData) 
{
	DWORD nByte;
		
	if (!HW32 || !HW32->fOpenDrive) return;

	DeviceIoControl(HW32->hDrv,
					CtlCode(GET_MSR_VALUE),
						&RegNumber, sizeof(RegNumber),
						MsrData, sizeof(MSR_DATA),
						&nByte, NULL);

}


void  VICFN CPUID(PVicHW32Descriptor HW32, CPUID_RECORD * pCpuIdRec)
{
	DWORD nByte;
		
	if (!HW32 || !HW32->fOpenDrive) return;

	DeviceIoControl(HW32->hDrv,
					CtlCode(GET_CPUID),
						pCpuIdRec, sizeof(CPUID_RECORD),
						pCpuIdRec, sizeof(CPUID_RECORD),
						&nByte, NULL);


}


//-------------------------------------------------------------
BOOL 
APIENTRY DllMain(HANDLE hModule, 
                 DWORD  ul_reason_for_call, 
        		 LPVOID lpReserved)
{

	ULONG i;
	HANDLE          KHandle;
	OSVERSIONINFO   winver;
	TIsWow64        IsWow64Process;


    switch( ul_reason_for_call ) {

		case DLL_PROCESS_ATTACH:

			IsWow64 = FALSE;


			if ((GetVersion() & 0x80000000)==0)
			{
				winver.dwOSVersionInfoSize = sizeof(winver);
				GetVersionEx(&winver);
				if (winver.dwMajorVersion > 4)
				{
					KHandle = LoadLibrary("kernel32.dll");
					if (KHandle != NULL)
					{
						IsWow64Process = (TIsWow64)GetProcAddress(KHandle, "IsWow64Process");
						if (IsWow64Process)
						{
							IsWow64Process(GetCurrentProcess(), &IsWow64);
						}
						FreeLibrary(KHandle);
					}
				}
			}


			LocalInstance = 77;
			VirtualLock(HW32_STRUCT, sizeof(HW32_STRUCT));

            
			for (i=0; i<16; i++) {
			

				if (!InstanceOpened[i]) {

					

					LocalInstance = i;
					pHW32 = &HW32_STRUCT[LocalInstance];

					if ( OpenTVic() ) {

						InstanceOpened[LocalInstance] = 1;
						
						return TRUE;
					}
					else {
						pHW32 = NULL;
						InstanceOpened[LocalInstance] = 0;
						LocalInstance = 99;					
						return TRUE;

					}

					break;
				}
			}		
			
			pHW32 = NULL;
            
			break;

        case DLL_PROCESS_DETACH :

			if (LocalInstance!=99) {
				CloseTVic();				
				InstanceOpened[LocalInstance] = 0;
			}
			LocalInstance = 99;
			pHW32 = NULL;
          
	}
	return TRUE;
};

//-------------------------------------------------------------