
#ifndef __TVicVAR_H
#define __TVicVAR_H

#include "common.h"


#define  MaxMappedAreas            16
#define  MaxPins                   17
#define  MAX_RING_BUFFER           511 


#ifdef __cplusplus
    extern "C" {
#endif

ULONG CtlCode(ULONG Code);

typedef ULONG  (__stdcall * TRing0Function)(PVOID parm);
typedef void   (__stdcall * TOnHWInterrupt)(USHORT IRQNumber);
typedef void   (__stdcall * TOnFastTimer)();
typedef void   (__stdcall * TOnDelphiInterrupt)(HANDLE Component, WORD IRQNumber);

typedef void   (__stdcall * TOnHWInterruptEx)(USHORT IRQNumber,pIrqClearRec IrqRec);
typedef void   (__stdcall * TOnDelphiInterruptEx)(HANDLE Component, WORD IRQNumber,pIrqClearRec IrqRec);

typedef void   (__stdcall * TKbHookHandler)(BYTE scan_code);
typedef void   (__stdcall * TKbDelphiHandler)(HANDLE Componen, BYTE scan_code);
typedef HANDLE (__stdcall * TOpenVxDHandle)(HANDLE); 

typedef BOOL   (__stdcall * TEnumerateCallBack)(HANDLE HW32,
												BYTE bus,
												BYTE dev,
												BYTE func,
												PVOID pCfg);

//===========Find LPT ===========================================================
#define	ResType_IO    = 0x00000002;      // Physical IO address resource.
#define	ResType_DMA   = 0x00000003;      // DMA channels 0-7 resource.
#define	ResType_IRQ   = 0x00000004;      // IRQ 0-15 resource.

typedef struct  _TPort95Config
{
    DWORD LengthRecord;
    DWORD TypeRecord;   // ResType_IO   = $00000002;
    WORD IOD_Count;
    WORD IOD_Type;
    WORD IOD_Alloc_Base;
    WORD IOD_Alloc_End;
    WORD IOD_DesFlags;
    BYTE IOD_Alloc_Alias;
    BYTE IOD_Alloc_Decode;
    WORD IOR_Align;		// Mask for base alignment
    WORD IOR_nPorts;	// Number of ports
    WORD IOR_Min;		// Min port address
    WORD IOR_Max;		// Max port address
    WORD IOR_RangeFlags;// Flags
    BYTE IOR_Alias;		// Alias offset
    BYTE IOR_Decode;	// Address specified
}TPort95Config,*pPort95Config;

typedef struct _TDMA95Config 
{
	DWORD LengthRecord;
	DWORD TypeRecord;   // ResType_DMA   = $00000003;
	BYTE DD_Flags;
	BYTE DD_Alloc_Chan;	// Channel number allocated
	BYTE DD_Req_Mask;
	BYTE DD_Reserved;
}TDMA95Config,*pDMA95Config ;

typedef struct _TIRQ95Config
{
	DWORD LengthRecord;
	DWORD TypeRecord;	// ResType_IRQ   = $00000004;
	WORD IRQD_Flags;
	WORD IRQD_Alloc_Num;// Allocated IRQ number
	WORD IRQD_Req_Mask;
	WORD IRQD_Reserved;
}TIRQ95Config,*pIRQ95Config;

//========================================================================
//======================    Windows NT/2000/XP   =========================
//========================================================================

#define CmResourceTypePort             =  1;
#define CmResourceTypeInterrupt        =  2;
#define CmResourceTypeMemory           =  3;
#define CmResourceTypeDma              =  4;

typedef long int PHYSICAL_ADDRESS[2];

typedef struct _TPortResource_NT
{
    PHYSICAL_ADDRESS Start;
    long int Length;
}TPortResource_NT,*pPortResource_NT;

typedef struct _TInterruptResource_NT
{
    long int Level;
    long int Vector;
    long int Affinity;
}TInterruptResource_NT,*pInterruptResource_NT;

typedef struct _TDMAResource_NT
{
    long int Channel;
    long int PortAddr;
    long int Reserved1;
}TDMAResource_NT,*pDMAResource_NT;

typedef struct _CM_PARTIAL_RESOURCE_DESCRIPTOR
{
    BYTE TypeResource;		// Specifies type of resource
    BYTE ShareDisposition;  // Specifies how this resourse can be shared
    WORD Flags;				// Specifies type-dependent information

	union
	{
		TPortResource_NT PortResource;
		TInterruptResource_NT InterruptResource;
		TDMAResource_NT DMAResource;
	};
}CM_PARTIAL_RESOURCE_DESCRIPTOR,*pCM_PARTIAL_RESOURCE_DESCRIPTOR;

typedef struct _CM_PARTIAL_RESOURCE_LIST
{
    WORD Version;           // The version number of this structure.
    WORD Revision;          // The revision of this structure.
    long int Count;			// The number of partial resource descriptors
    CM_PARTIAL_RESOURCE_DESCRIPTOR PartialDescriptors[8];
}CM_PARTIAL_RESOURCE_LIST,*pCM_PARTIAL_RESOURCE_LIST;

typedef struct _CM_FULL_RESOURCE_DESCRIPTOR
{
    DWORD InterfaceType;	// Specifies the bus interface type
    DWORD BusNumber;		// The zero-based number for this bus
    CM_PARTIAL_RESOURCE_LIST PartialResourceList;
}CM_FULL_RESOURCE_DESCRIPTOR,*pCM_FULL_RESOURCE_DESCRIPTOR;

typedef struct _CM_RESOURCE_LIST
{
    long int Count;         // The number of full resource descriptors
    CM_FULL_RESOURCE_DESCRIPTOR List[8];
}CM_RESOURCE_LIST,*pCM_RESOURCE_LIST;


//===========================================================================
//============    TFindLpt Class Declarations      ==========================
//===========================================================================

typedef struct _TFindLpt

{

	BOOL m_Win95;
	BOOL m_NT5;
	char m_ClassN[256];
    WORD m_Devices;
    BYTE m_IRQCounter;
	BYTE m_IRQNumber;
    BYTE m_DMACounter;
    BYTE m_DMAChannel; 
    BYTE m_PortCounter;
    WORD m_PortBase[2];      
    WORD m_PortEnd[2];

};

    BOOL SearchLpt_9X();
    BOOL SearchLpt_NT();
	void OpenFindLpt();
    BOOL SearchLpt(BYTE Port_Number);
	BYTE GetNumIrqs(); 
    BYTE GetIrqVector();
	BYTE GetNumDmas();
    BYTE GetDMAChannel(); 
	BYTE GetNumPorts();
    WORD GetPortBase(BYTE Index); 
	WORD GetPortEnd(BYTE Index); 


#pragma pack(1)

typedef struct {


    HANDLE     hDrv;
	DWORD      DriverInstance;

	HMODULE    hDll;

	ULONG      fLastDebugCode;

	CallGate   CallGateInfo;
	BOOLEAN    fCallGateCreated;

	BOOL       LptIrqForced;
    
	BOOL      fWin95;
    BOOL      fNT5;

    USHORT    fLptAcquired[3]; // 0 - free; 1 - by us; 2 - by other
	HANDLE    hLptAcquired[3];

	BOOL      fBiosMethod;
	BOOL      fRegistry;
	BOOL      fStarted;

	TOpenVxDHandle fOpenVxDHandle;
	
    SC_HANDLE schSCManager;
	char      fServiceName[48];


    BOOL	  fTerminated;
	BOOL      fHookTerminated;

    ULONG	  fInterface;     // Isa, Eisa, etc....
    ULONG	  fBus;			// Bus number
    ULONG	  fPhysLoPart;    // Bus-relative address
    ULONG     fPhysHiPart;    // Zero
    ULONG	  fTypeMem;       // 0 is memory, 1 is I/O
    ULONG	  fMemorySize;    // Length of section to map

    PVOID	  fMappedPointers[MaxMappedAreas];
    ULONG     fMappedSizes[MaxMappedAreas];
	ULONG     fMappedAddresses[MaxMappedAreas];
	short     fMappedAreas;

    pSharedBuffer  fpLockedMemory;
	pSharedBuffer  fpInternalLockedMemory; 
	
    HANDLE	  fLocEvent[16];
	HANDLE	  fKernelEvent[16];
	HANDLE    fEventIRQSet;

	HANDLE    f64IrqEvent;
    HANDLE    f64HookEvent;
	ULONG     fCurrIrqNumber;

	HANDLE    fHookLocEvent;
	HANDLE    fHookKernelEvent;
	UCHAR     fHookReason;
	HANDLE    fHookComponent;
    	
    BOOL	  fHardAccess;
    BOOL      fMemoryMapped;
    BOOL      fOpenDrive;

    TOnHWInterrupt	OnHwInterrupt[16];
	HANDLE          Components[16];
	ULONG      IrqShared[16];
	TKbHookHandler  fOnKeystroke;

	TOnFastTimer  OnTimer;
	BOOLEAN   IsTimerSet; 

	BOOL      fMasked[16];
	BOOL      fHooked;
    HANDLE	  fThreadId;
    HANDLE	  fThreadHandle;
    HANDLE	  fHookThreadId;
    HANDLE	  fHookThreadHandle;

	ULONG     fLastHandled[16];
	ULONG     fLastCounter[16];
    
    WORD      fLPTAddresses[4];
	WORD      fLPTBasePort;
	BYTE      fDataWritePorts[3];
	BYTE      fDataReadPorts[3];
	BYTE      fLPTNumber;
	BYTE      fLPTs;

} TVicHW32Descriptor, *PVicHW32Descriptor;

#pragma pack(1)

BOOL  PrepareRing0Call(PVicHW32Descriptor HW32);
BOOL  DestroyRing0Call(PVicHW32Descriptor HW32);
void  InstallStartLoadDriver(PVicHW32Descriptor HW32, char * ServiceName, char * EntryPoint);
void  CloseStopUnloadDriver(PVicHW32Descriptor HW32, char * ServiceName);



#ifdef __cplusplus
}
#endif

#endif